#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "textedit.h"
#include "./lsapi.h"

#include <fstream.h>
#include <list>
#include <string>
using namespace std;

//
// to do, add escape sequences
//

char filename[256];
string comment = ";";
BOOL textSubst = FALSE;
BOOL NotCaseSensivie = FALSE;
BOOL calc = FALSE;
char* rest;
/*
void MessageBox(int Num)
{
	char temp[10];
	sprintf(temp, "%d", Num);
	MessageBox(NULL, temp, "Error", MB_OK);
}
*/
// find and replace a string, buf must be big enough to hold the new string
void findReplace(char *buf, char* find, char* replace)
{
	char *start, tailCopy[1024];
	while (strstr(buf, find))
	{
		start = strstr(buf, find);
		strcpy(tailCopy, start+strlen(find));
		strcpy(start, replace);
		strcat(buf, tailCopy);
	}
}

// calcutator
void parseCalc(char *text)
{
	char *start, *tail, tailCopy[1024], num[30], buffer[1024];
	int error, number;

	num[0] = '\0';
	while  (strstr(text, "{") && (strstr(text, "{") < strstr(text, "}")) )
	{
		start = strstr(text, "{");
		tail = strstr(text, "}");
		tail++;
		strcpy(tailCopy, tail);
		strcpy(buffer, start+1);
		buffer[strlen(start) - strlen(tail) - 2] = '\0';

		RECT r;
		GetClientRect(GetDesktopWindow(),&r);
		sprintf(num, "%d", r.bottom);
		findReplace(buffer, "height", num);
		sprintf(num, "%d", r.right);
		findReplace(buffer, "width", num);

		error = 0;
		Evaluate(buffer, &error, num, sizeof(num));
		if (error)
			strcpy(num, "error");
		else
		{
			number = atoi(num+1);
			sprintf(num, "%d", number);
		}

		strcpy(start, num);
		strcpy(start+strlen(num), tailCopy);
	}
}

void getFilename(char* arg, char Filename[256])
{
	int i;
	// if it's enclosed in quotes
	if (arg[0] == '"')
	{
		i = 1;
		while (arg[i] != '"' && i < strlen(arg))
		{
			Filename[i-1] = arg[i];
			i++;
		}
		Filename[i] = '\0';
		i++;
	}
	else // not enclosed in quotes
	{
		i = 0;
		while (arg[i] != ' ' && i < strlen(arg))
		{
			Filename[i] = arg[i];
			i++;
		}
		Filename[i] = '\0';
	}

	rest = arg + i + 1;

	if (calc)
		parseCalc(rest);
}

// converts ^ to !
void removeTilde(char* rest)
{
	for (int i=0; i < strlen(rest); i++)
	{
		if (rest[i] == '^')
			rest[i] = '!';
	}
}

// appends text to the end of a file
void TextAppend(HWND caller, char* arg)
{
	getFilename(arg, filename);
	::ofstream file;
	file.open(filename, ios::nocreate | ios::app);
	if (textSubst == TRUE)
		removeTilde(rest);
	if (!file.fail())
		file << rest << endl;
	file.close();
}

// grabs a number from a string
int getSingleNum(char *str)
{
	int i=0;
	char numStr[50];
	while (str[i] != ' ' && i < strlen(str))
	{
		numStr[i] = str[i];
		i++;
	}
	numStr[i] = '\0';
	i++;

	rest += i;
	return atoi(numStr);	
}

list<int> TextRemove(char *arg, bool single)
{
	list<string> lines;
	int singleNum = 0;
	int foundNum = 1;
	list<int> delLines;

	getFilename(arg, filename);
	
	if (textSubst == TRUE)
		removeTilde(rest);

	//temp
//	MessageBox(NULL, rest, "remove", MB_OK);

	if (single)
		singleNum = getSingleNum(rest);

	::ifstream file;
	file.open(filename, ios::nocreate);
	if (!file.fail())
	{
		char line[4096];
		int curLine = 1;
		while (!file.eof())
		{
			file.getline(line, 4096, '\n');
			if (rest[strlen(rest) - 1] == '*')
			{
				if ( strncmp(line, rest, strlen(rest) - 1) 
					&& !NotCaseSensivie)
				{
					lines.push_back(line);
				}
				else if ( _strnicmp(line, rest, strlen(rest) - 1) 
					&& NotCaseSensivie)
				{
					lines.push_back(line);
				}
				else
				{
					if (foundNum != singleNum && single)
						lines.push_back(line);
					else
						delLines.push_back(curLine);
					foundNum++;
				}
			}
			else if (strcmp(line, rest) && !NotCaseSensivie)
				lines.push_back(line);
			else if (stricmp(line, rest) && NotCaseSensivie)
				lines.push_back(line);
			else 
			{
				if (foundNum != singleNum && single)
					lines.push_back(line);
				else
					delLines.push_back(curLine);
				foundNum++;
			}
			curLine++;
		}
		file.close();
		
		if (lines.size())
			lines.pop_back();

		::ofstream file2;
		file2.open(filename, NULL);
		list<string>::const_iterator lci;
		for (lci = lines.begin(); lci != lines.end(); lci++)
		{
			file2 << lci->data() << endl;
		}
		file2.close();
		lines.clear();
	}

	return delLines;
}

void TextDelSingle(HWND caller, char* arg)
{
	TextRemove(arg, true);
}

void TextDel(HWND caller, char* arg)
{
	TextRemove(arg, false);
}

void TextSetComment(HWND caller, char* arg)
{
	comment = arg;
}

// comments lines
void TextComment(HWND caller, char* arg)
{
	list<int> lineNums;
	list<string> lines;
	char *token;

	getFilename(arg, filename);

	token = strtok(rest, ",\t ");
	while( token != NULL )
	{
		lineNums.push_back(atoi(token));
		token = strtok(NULL, ",\t ");
	}

	lineNums.sort();

	::ifstream file;
	file.open(filename, ios::nocreate);
	if (!file.fail())
	{
		char line[4096];
		int curLine = 1;

		while (!file.eof())
		{
			file.getline(line, 4096, '\n');
			if (curLine == *lineNums.begin())
			{
				lines.push_back(comment + " " + string(line));
				lineNums.pop_front();
			}
			else
			{
				lines.push_back(line);
			}
			curLine++;
		}

		file.close();
		if (lines.size())
			lines.pop_back();

		::ofstream file2;
		file2.open(filename, NULL);
		list<string>::const_iterator lci;
		for (lci = lines.begin(); lci != lines.end(); lci++)
		{
			file2 << lci->data() << endl;
		}
		file2.close();
		lines.clear();
	}
}

void TextInsert(HWND caller, char* arg)
{
	list<string> lines;
	int insertNum = 0;

	getFilename(arg, filename);
	
	if (textSubst == TRUE)
		removeTilde(rest);

	insertNum = getSingleNum(rest);

	::ifstream file;
	file.open(filename, ios::nocreate);
	if (!file.fail())
	{
		int curLine = 1;
		char line[4096];
		while (!file.eof())
		{
			if (curLine == insertNum)
				lines.push_back(rest);
			file.getline(line, 4096, '\n');
			lines.push_back(line);
			curLine++;
		}

		file.close();

		if (lines.size())
			lines.pop_back();

		::ofstream file2;
		file2.open(filename, NULL);
		list<string>::const_iterator lci;
		for (lci = lines.begin(); lci != lines.end(); lci++)
		{
			file2 << lci->data() << endl;
		}
		file2.close();
		lines.clear();
	}
}

void getString(char* str, char temp[4096])
{
//	MessageBox(NULL, str, "getstring", MB_OK);
	int offset = 0;
	while (str[offset] != '"' && offset < strlen(str))
		offset++;

	offset++;
	int i = 0, offset2 = 0;

	while (str[offset+i] != '"' && (offset+i < strlen(str)))
	{
		if (str[offset+i] == '^' && str[offset+i+1] == '"')
		{
			i++;
			offset2--;
		}
		temp[i+offset2] = str[offset+i];
		i++;
	}

	temp[i+offset2] = '\0';
	i++;

	rest += i + 1;
}

void TextReplace(HWND caller, char* arg)
{
	list<string> lines;
	list<int> delLines;
	char find[4096], replace[4096];

	getFilename(arg, filename);

	getString(rest, find);
	getString(rest, replace);

	if (textSubst == TRUE)
	{
		removeTilde(find);
		removeTilde(replace);
	}

	char temp[4096] = "\"";
	strcat(temp, filename);
	strcat(temp, "\" ");
	strcat(temp, find);
	
	delLines = TextRemove(temp, false);

	list<int>::const_iterator lci;
	for (lci = delLines.begin(); lci != delLines.end(); lci++)
	{
		char cnum[10];
		sprintf(cnum, "%d", *lci);
		strcpy(temp, "\"");
		strcat(temp, filename);
		strcat(temp, "\" ");
		strcat(temp, cnum);
		strcat(temp, " ");
		strcat(temp, replace);
		TextInsert(caller, temp);
	}
}

void TextCopyFile(HWND caller, char* arg)
{
	int count;
	char* tokens[3];
	char fileSource[256], fileDest[256], extra[4096], line[4096];
	tokens[0] = fileSource;
	tokens[1] = fileDest;

	count = LCTokenize(arg, tokens, 2, extra);

	if (!strlen(fileDest))
		return;

	::ifstream in(fileSource);
	::ofstream out(fileDest);

	in.getline(line, 4096);

	while (!in.eof())
	{
		out << line << endl;
		in.getline(line, 4096);
	}
	
	in.close();
	out.close();
}

//void test(HWND caller, char* arg)
//{
//}

int initModule(HWND ParentWnd, HINSTANCE dllInst, wharfDataType* wd)
{
	return initModuleEx (ParentWnd, dllInst, wd->lsPath);
}

int initModuleEx(HWND ParentWnd, HINSTANCE dllInst, LPCSTR szPath)
{
	AddBangCommand("!TextAppend", TextAppend);
//	AddBangCommand("!TextAdd", TextAppend);
	AddBangCommand("!TextInsert", TextInsert);
	AddBangCommand("!TextReplace", TextReplace);
	AddBangCommand("!TextDel", TextDel);
	AddBangCommand("!TextDelSingle", TextDelSingle);
	AddBangCommand("!TextComment", TextComment);
	AddBangCommand("!TextSetCommentChar", TextSetComment);
	AddBangCommand("!TextCopyFile", TextCopyFile);
	textSubst = GetRCBool("TextSubst", TRUE);
	NotCaseSensivie = GetRCBool("TextNotCaseSensitive", TRUE);
	calc = GetRCBool("TextCalculate", TRUE);
//	AddBangCommand("!test", test);
//	createFile = GetRCBool("TextCreateFile", TRUE);
//	backup = GetRCBool("TextBackup", TRUE);

	return 0;
}

void quitModule(HINSTANCE dllInst)
{
	// clean up
}
